#version 130

in vec4 v_Position;
in vec4 v_Normal;
in vec4 v_Color;
flat in ivec3 v_TileOffset;

const float AMBIENT_CONTRIB = 0.8;
const float DIFFUSE_CONTRIB = 1.0 - AMBIENT_CONTRIB;

const vec4 LIGHT_POSITION = vec4(-5.0, 5.0, 0.0, 1.0);

out vec4  f_Color;
out ivec4 f_TileId;

void main()
{
    vec4 FragToLight = normalize(LIGHT_POSITION - v_Position);

    float diffuseAmount = max(0.0, dot(v_Normal, FragToLight));

    f_Color = v_Color * (diffuseAmount * DIFFUSE_CONTRIB + AMBIENT_CONTRIB);
    f_TileId = ivec4(v_TileOffset, 0);
}